import * as angular from 'angular';

class ContentStatusService {
    Authorization: string;
    /*@ngInject*/
    constructor(
        private $q,
        private $http,
        private TokenService
    ) {
        this.Authorization = this.TokenService.getAuthToken();
    }

    getContentStatus = (documents) => {
        const deferred = this.$q.defer();
        this.$http({
            method: 'POST',
            url: `${process.env.ADD_CONTENT_BFF_URL}/content-status`,
            headers: {
                'Authorization': this.Authorization,
            },
            data: { documents: documents.map(document => document.documentId) }
        })
            .then(response => {
                const updatedDocuments = [];
                const documentStatuses = response.data;
                documents.forEach(document => {
                    let documentStatus = documentStatuses.find(documentStatus => documentStatus.id === document.documentId);
                    if (Object.keys(documentStatus.content).length) {
                        updatedDocuments.push({...documentStatus.content, ...document, contentIndexed: true})
                    } else {
                        updatedDocuments.push(document);
                    }
                })

                deferred.resolve(updatedDocuments);
            })
            .catch(deferred.reject);

        return deferred.promise;
    };
}

export default ContentStatusService;
